import javax.swing.*;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;

class ExecuteCommandDialog extends JDialog {
    private boolean canceled = true;
	private String command;
	private boolean async = true;
	private Integer timeout = new Integer(0);
	private JOptionPane optionPane;

	public boolean isCanceled() {
        return canceled;
    }

	public String getCommandLine() {
        return command;
    }
	
	
	public boolean isAsync() {
        return async;
    }
	
	public Integer getTimeout() {
        return timeout;
    }
	
	public ExecuteCommandDialog(Frame aFrame) {
        super(aFrame, true);
        setTitle("Execute Remote Command");
		
        final JLabel commandLabel = new JLabel("Command: ");
		final JTextField commandField = new JTextField();
		final JCheckBox asyncBox = new JCheckBox("Wait for command to complete", false);
		final JLabel timeoutLabel = new JLabel("Timeout (enter 0 to allow infinite wait or other number to specify command timeout in seconds): ");
		final JTextField timeoutField = new JTextField("0");
		timeoutField.setPreferredSize(new Dimension(50, 20));
		final JPanel extraOptions = new JPanel();
		extraOptions.add(timeoutLabel);
		extraOptions.add(timeoutField);
		
		
		Object[] array = {commandLabel, commandField, asyncBox, extraOptions};

        final String btnExecute = "Execute";
        final String btnCancel = "Cancel";
        Object[] options = {btnExecute, btnCancel};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.OK_CANCEL_OPTION,
                                    null,
                                    options,
                                    options[0]);
		setContentPane(optionPane);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });


        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                     Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnExecute)) {
						canceled = false;
                        command = commandField.getText();
						async = !asyncBox.isSelected();
						timeout = (new Integer(timeoutField.getText()));
                    }

					setVisible(false);
                }
            }
        });
    }
}
