import javax.swing.*;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;

class ExecuteScriptDialog extends JDialog {
    private boolean canceled = true;
	private String script = null;
	private JOptionPane optionPane;

	public boolean isCanceled() {
        return canceled;
    }
	
	public String getScript() {
        return script;
    }
	
	
	public ExecuteScriptDialog(Frame aFrame) {
        super(aFrame, true);
        setTitle("Enter Script");
		
        final JLabel scriptLabel = new JLabel("Job Automation Language Script: ");
		final JTextArea scriptField = new JTextArea( 
							"///////////////////////////////////////////////////////\n" + 
							"// This sample script demonstrates how to establish\n" + 
							"// RAS connection and then use it to replicate files\n" + 
							"// between your Web server directory and a local\n" + 
							"// directory on your computer.\n" + 
							"///////////////////////////////////////////////////////\n" + 
							"\n" + 
							"// declare variables\n" + 
							"Dim( connection, number )\n" + 
							"\n" + 
							"// Establish RAS connection\n" + 
							"RASDial( \"my ISP\", \"my user name\", \"my password\", connection )\n" + 
							"\n" + 
							"// Synchronizes files on the remote Web server directory with files on the local computer\n" + 
							"SyncFTPDir( \"LOCAL\", \"ftp.mycompany.com\", \"webmaster\", \"password\", &\n" + 
							"         \"c:\\\\webserver\\\\1999\\\\documents\", &\n" + 
							"         \"/1999/documents\", &\n" + 
							"        True, False, True, True )\n" + 
							"\n" + 
							"// terminate RAS connection\n" + 
							"RASHangUp( connection )\n");
		
		final JScrollPane editor = new JScrollPane(scriptField);
        editor.setMinimumSize(new Dimension(400, 300));
		Object[] array = {scriptLabel, editor};

        final String btnExecute = "Execute";
        final String btnCancel = "Cancel";
        Object[] options = {btnExecute, btnCancel};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.OK_CANCEL_OPTION,
                                    null,
                                    options,
                                    options[0]);
		optionPane.setPreferredSize(new Dimension(450, 400));
		setContentPane(optionPane);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                     Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnExecute)) {
						canceled = false;
                        script = scriptField.getText();
                    }
					
					setVisible(false);
                }
            }
        });
    }
}
